package jsr.daemon;

import java.util.Enumeration;

/**
 * interface for supplying configuration attributes of a daemon
 *
 * @author   Thomas Kopp
 * @version  0.9, 2000-11-16
 */
public interface DaemonConfig {
    
    /**
     * method for accessing a configuration attribute
     * attribute values are filled in via a daemon context
     * @param name the name of the attribute to be retrieved
     * @return value of the attribute
     */
    public Object getAttribute(String name);
    
    /**
     * method for listing attribute names of the configuration
     * @return enumeration of the attribute names available
     */
    public Enumeration getAttributeNames();
    
    /**
     * method for accessing the name of a daemon 
     * a name is set via a daemon context
     * @return name of the daemon
     */
    public String getDaemonName();
}
