package jsr.daemon.pausable;

import jsr.daemon.*;

/**
 * interface for a service providing container in order to control the life cycle of a pausable daemon
 *
 * @author   Thomas Kopp
 * @version  0.9, 2000-11-16
 */
public interface PausableDaemonControl extends DaemonControl {
    
    /**
     * start method called in order to start or restart the daemon
     * @exception DaemonException thrown by the daemon if starting or restarting fails
     */
    public void start() throws DaemonException;
    
    /**
     * pause method called in order to stop the daemon
     */
    public void stop();
}
