package jsr.daemon.pausable;

import java.util.*;

import jsr.daemon.*;

/**
 * helper class for dispatching pausable daemon events to bound listeners
 *
 * @author   Thomas Kopp
 * @version  0.9, 2000-11-16
 */
public class PausableEventHandler extends DaemonEventHandler {

    /** 
     * default constructor for this event handler
     */
    public PausableEventHandler() {
        super();
    }    

    /**
     * method for informing the event handler about a pause state change
     * @param pausable the pausable daemon changing its pause state
     * @param paused the target pause state
     * @param throwable a throwable for indicating a possible exception
     */
    public void paused(Pausable pausable, boolean paused, Throwable throwable) {
        Iterator listeners = getListeners();
        if (null != listeners) {
           while (listeners.hasNext()) {
                 Object listener = listeners.next();
                 if (listener instanceof PausableListener) {
                    ((PausableListener)(listener)).paused(pausable, paused, throwable);
                 }
           }
        }
    }
}
