package jsr.daemon.pausable.jni;

import jsr.daemon.jni.*;

import jsr.daemon.pausable.*;

/**
 * adapter class for docking a native pausable listener if applicable
 *
 * Native daemon containers might use this class for implementing a pausable listener interface.
 *
 * Note: ".jni" named sub-packages are not considered to be part of the Java daemon api.
 *       They are supplied as native implementation helpers, only.
 *
 * @author   Thomas Kopp
 * @version  0.9, 2000-11-16
 */
public class NativePausableAdapter extends NativeDaemonAdapter implements PausableListener {
   
    /**
     * method called by a daemon if pause state changes
     * @param pausable the pausable daemon changing its pause state
     * @param paused flag indicating the target pause state
     * @param throwable a throwable for indicating a possible exception
     */
    public native void paused(Pausable pausable, boolean paused, Throwable throwable);
}
